      PROGRAM MALLOY
	 IMPLICIT NONE
C
C *********************************************************************
C LATP is lattice parameter: value for iron is used
C RGAS is Gas constant, R.
C AVOG is Avogadro constant.
C MOLV is molar volume calculated for iron.
C ATOD is diameter of atom.
C AVOA and AVOB are volume per atom for component A and B respectively.
C MA and MB are atoms per particle of component A and B respectively.
C X is mole fraction.
C NA and NB are number of particles of A and B respectively.
C SA is total surface area of the particles.
C VT is total volume of the particles.
C SV is surface area per unit volume.
C VB is volume fraction of material within a grain boundary.
C SIGMA is interface energy per unit area.
C DELTAE is molar interface energy.
C *********************************************************************
C
       DOUBLE PRECISION KTEMP,OMEGA,LATP,RGAS,AVOG,MOLV,ATOD,AVOA,
     &                  AVOB,DUMMY,MA,MB,MDUMMY,SIGMA,X,NA,NB,SA,
     &                  SV,VB,VT,DELTAE,DELTAG,DELTAH,DELTAS,TDELTAS
       INTEGER I,J
C
       OPEN(11, FILE='PRN.DAT')
       WRITE(*,3)
       READ(*,*) KTEMP,OMEGA
       WRITE(11,11)
       WRITE(6,11)
C
       LATP = 2.867D-10
       RGAS = 8.31432D+00
       AVOG = 6.023D+23
       MOLV = 8.634D-7
       ATOD = 2.0*(SQRT(3.0D+00)/2.0D+00)*LATP
       AVOA = LATP**3.0/2.0
       AVOB = AVOA
C
C This section defines the particle sizes
C
       DO 10 J=1,10
         DUMMY = (10.0-1.0*J)
         MA = 10.0D+00**DUMMY
         MB = MA
C
C Interface energy per unit area
C
         MDUMMY = 1.0D+7
         IF (MA .GT. MDUMMY) THEN
            SIGMA = 0.5D+00
         ELSE
            SIGMA = 0.5*(1.0-((MDUMMY-MA)/MDUMMY))
         ENDIF
C
         DO 1 I=1,51
           X = (I-1)*0.2D-01
          NA = AVOG*(1-X)/MA
          NB = AVOG*X/MB
          SA = 3.0*(NA*(MA*AVOA)**(2.0/3.0) + 
     &          NB*(MB*AVOB)**(2.0/3.0))
          VT = NA*MA*AVOA + NB*MB*AVOB
          SV = SA/VT
          VB = SV*2.0*ATOD

C Molar Interface Energy

          DELTAE = SV*SIGMA*MOLV
C

          IF (X .EQ. 0.0D+00 .OR. X .EQ. 1.0D+00) THEN
             DELTAS = 0.0D+00
             TDELTAS = 0.0D+00
             DELTAH = 0.0D+00
          ELSE

C Molar Entropy

             DELTAS = RGAS*((((1-X)*MB+X*MA)/(MA*MB))*
     &                DLOG(AVOG*(((1-X)*MB+X*MA)/(MA*MB)))
     &                -((1-X)/MA)*DLOG(AVOG*((1-X)/MA))
     &                -(X/MB)*DLOG(AVOG*X/MB))
             TDELTAS = -KTEMP*DELTAS

C Molar Enthalpy

             DELTAH = X*(1-X)*VB*OMEGA

C Molar Free Energy

             DELTAG = DELTAH + TDELTAS + DELTAE
          ENDIF

C
C
          WRITE(11,2)MA, MB,X,DELTAS,TDELTAS,DELTAG,KTEMP,SIGMA, DELTAE
          WRITE(6,2)MA, MB,X,DELTAS,TDELTAS,DELTAG,KTEMP,SIGMA, DELTAE
C
1       CONTINUE
        WRITE(11,11)
        WRITE(6,11)
10     CONTINUE
       CLOSE(11)
       STOP 
2      FORMAT(2D10.2,F6.2,D10.2,2F14.7,F8.0,3F14.7)
3      FORMAT(10x, ' KTEMP, OMEGA')
11     FORMAT(// 7x,'MA,    MB,   X,   DELTAS,   TDELTAS,   '
     &    '    DELTAG,     KTEMP,    SIGMA,    DELTAE'/)
      END
